// SynchronizedDictionary.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation

internal struct SynchronizedDictionary<K: Hashable, V> {

    private var dictionary = [K: V]()
    private let lock = NSRecursiveLock()

    internal subscript(key: K) -> V? {
        get {
            lock.withLock {
                self.dictionary[key]
            }
        }
        set {
            lock.withLock {
                self.dictionary[key] = newValue
            }
        }
    }
}
